#!/usr/local/bin/perl -w

$echar_sleep = .020;  
$echar_notsleep = .080;
$nbint = 4150;

@month_days_2000 = (
"January=" . "31",
"February=" . "30",
"March=" . "31",
"April=" . "30",
"May=" . "31",
"June=" . "30",
"July=" . "31",
"August=" . "31",
"Sepember=" . "30",
"October=" . "31",
"November=" . "30",
"December=" . "31");	      

@month_days_2001 = (
"January=" . "31",
"February=" . "28",
"March=" . "31",
"April=" . "30",
"May=" . "31",
"June=" . "30",
"July=" . "31",
"August=" . "31",
"Sepember=" . "30",
"October=" . "31",
"November=" . "30",
"December=" . "31");	      

#               name          Tres
%program_info = (
"sleep",           "sleep#"       . "3600",
"deepsleep",       "deepsleep#"   . "3600",
"sleeplcd",        "sleeplcd#"    . "3600",
"sleepdc",         "sleepdc#"     . "3600",
"mpeg206high",     "mpeg206high#" .  " 90",
"dectalk74low",    "tts74low#"    .  "195",
"dectalk74high",   "tts74high#"   .  "195",
"dectalk206high",  "tts206high#"  .  "195",
"wav59high",       "wav59high#"   .  "252",
"wav206high",      "wav206high#"  .  "252",
"idle59low",       "idle59low#"   .  "600",
"idle59high",      "idle59high#"  .  "600",
"idle133high",     "idle133high#" .  "600",
"idle206high",     "idle206high#" .  "600",
"natspeak206high", "dict206high#" .  "102",
);

sub usage {
    warn("Usage: gpgin <filename>+\n");
    exit 1;
}

sub countdaystomonthsince2000jan01 { # current_month  # current_year
    local($current_month) = $_[0];
    local($current_year) = $_[1];
    $sum = 0;
    foreach $i (@month_days_2000) {
	($month, $daysinmonth) = split(/=/, $i);
	last if (($current_year eq "2000") && ($current_month eq substr($month, 0, length $current_month)));
	$sum += $daysinmonth;
    }
    die ("Month not found!\n") 
	if (($current_year eq "2000") && ($current_month ne substr($month, 0, length $current_month)));
    if ($current_year eq "2001") {
	foreach $i (@month_days_2001) {
	    ($month, $daysinmonth) = split(/=/, $i);
	    last if ($current_month eq substr($month, 0, length $current_month));
	    $sum += $daysinmonth;
	}
	die ("Month not found!\n") if ($current_month ne substr($month, 0, length $current_month));
    }
    $sum;
}

sub countsecssince2000jan01 { 
    local($year) = $_[0];
    local($month) = $_[1];
    local($mday) = $_[2];
    local($hour) = $_[3];
    local($min) = $_[4];
    local($sec) = $_[5];
    local($secs) = &countdaystomonthsince2000jan01($month,$year)*24*3600+
	$mday*24*3600+
	    $hour*3600+
		$min*60+
		    $sec;
    $secs;
}


sub processit { # IN_FILEHANDLE 
    local($IN) = $_[0];
    local($pathname) = $_[1];

    $battery = 0;
    open(BFILE, "$pathname/STATS") || (die "Can't open $pathname/STATS: $!\n");
    while (<BFILE>) {
	if (/^Itsy \#\d+, battery\s+#(\d+)\D/) {
	    $battery = $1;
	    last;
	}
    }
    close(BFILE);

    while(<$IN>) {
	if (/^running command .\/doit  (\w+)\s+-speed\s+(\d+) -(\w+) /) {
	    $prefix = $1;
	    $command_index = sprintf("%s%d%s", $1, $2, $3);
	    if ($prefix =~ /sleep/) {
		$command_index = $prefix;
	    }
	    @tmp = split(/\#/, $program_info{$command_index});
#	    $command = $tmp[0];
	    $tres = $tmp[1];
	    $pmonth_last = "";
	    $nchars = 0;
	}
	elsif (/^\w+\s+(\w+)\s+(\d+)\s+(\d+):(\d+):(\d+)\s+P.T (\d+):  \+\s*$/) {
	    # eventually will be absolute time last character was seen
	    $pmonth_last = $1;
	    $pmday_last = $2;
	    $phour_last = $3;
	    $pmin_last = $4;
	    $psec_last = $5;
	    $pyear_last = $6;
	    $nchars++;
#	    printf "$pmonth_last $pmday_last $pyear_last $phour_last:$pmin_last:$psec_last\n";
	}
	elsif (/\/dev\/ttyS2 -f (\S+) init/) {
	    $outfile = $1;
	}
	elsif (/^Experiment seemed to take (\d+) seconds/) {
	    $seemedsecs = $1;

	    $lmonth = "";
	    open(LOGFILE, "$pathname/$outfile") || (die "Can't open $pathname/$outfile: $!\n");
	    while (<LOGFILE>) {
		if (/^# Ref. time: (\w+)\s+(\d+),\s+(\d+), (\d+):(\d+):(\d+\.\d+)\s+PST.$/) {
		    # labinst started
		    $lmonth = $1;
		    $lmday = $2;
		    $lyear = $3;
		    $lhour = $4;
		    $lmin = $5;
		    $lsec = $6;
#		    printf "$lmonth $lmday $lyear $lhour:$lmin:$lsec\n";
		    last;
		}
	    }
	    (($lmonth) && ($pmonth_last)) || (die "Can't find absolute time!\n");

	    # secs from 1/1/00 to time absolute time last character was seen
	    $psecs_last = &countsecssince2000jan01($pyear_last, $pmonth_last, $pmday_last, 
						   $phour_last, $pmin_last, $psec_last);
	    # secs from 1/1/00 to time lab measurement started
	    $lsecs = &countsecssince2000jan01($lyear, $lmonth, $lmday, 
						    $lhour, $lmin, $lsec);

#    printf "s: $psecs_last $seemedsecs   %f  $lsecs\n",  ($psecs_last-$seemedsecs);


	    # start counting the measurements in period after one experiment started
	    $startoffset = ($psecs_last-$seemedsecs) - $lsecs;

#    print "s: $startoffset\n";

	    while (<LOGFILE>) {
		if(/^(\d+\.\d+) /) {
		    $periodstart = $1;
#    print "p: $periodstart\n";
		    # make sure discard first measurement no matter what
		    last if (($startoffset < $periodstart) && ($periodstart > 2));
		}
	    }
	    $forcemint = $periodstart;
	    close(LOGFILE);

#	    $checkdiff = ($seemedsecs-($psecs_last-$lsecs));
#	    $checkdiff = (0-$checkdiff) if ($checkdiff < 0);
#	    ($checkdiff < 2) || (die "Discrepancy too great in experiment runtime calculation!\n");

	    $forcemaxt = $psecs_last-$lsecs;
#    print "maxt: $forcemaxt\n";
	    $tbat = $seemedsecs + $tres/2;

	    if ($outfile =~ /sleep/) {
		$echar = $echar_sleep;
	    }
	    else {
		$echar = $echar_notsleep;
	    }

	    printf "bin/pwrgraph -data -forcemint %f -forcemaxt %f " .
		"-tbat %d -tres %d -nchars %d -echar %f -nbint %d -battery %s %s/%s\n",
 	      $forcemint, $forcemaxt, $tbat, $tres, $nchars, $echar, $nbint, $battery, $pathname, $outfile;
	}
    }

}

FILE:
if ($#ARGV < 0) {
    &usage();
    &processit(STDIN);
}

while ($#ARGV >= 0) {
    $filename = shift @ARGV;
    open(FILE, $filename) || (die "Can't open $filename: $!\n");
    
    # discard path
    @data = split('/', $filename);
    pop(@data);

    processit(FILE, join('/', @data));
    
    close(FILE);
}

